package hu.uniobuda.nik.httpclient;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.text.Html;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

public class HTTPClientPeldaActivity extends Activity {
    
	EditText url,
			 urlPost,
			 username,
			 password;	
	Button urlConnection,
		   getButton,
		   postButton;
	
	File malkFile;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        malkFile = new File(Environment.getExternalStorageDirectory(), "malk.html");
        
        // UI elemek elérése
        url = (EditText)findViewById(R.id.url);
        urlPost = (EditText)findViewById(R.id.postUrl);
        username = (EditText)findViewById(R.id.user);
        password = (EditText)findViewById(R.id.pwd);
        urlConnection = (Button)findViewById(R.id.urlconnection);
        getButton = (Button)findViewById(R.id.httpget);
        postButton = (Button)findViewById(R.id.httppost);
        
        // URL Connection ---------------------------------
        urlConnection.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				
				try {
					
					// Forrás: INTERNET
					URL urlSource = new URL(url.getText().toString());					
					URLConnection conn = urlSource.openConnection();
					InputStream is = conn.getInputStream();
					
					// Mentés folyamata
					saveInputStream(is, malkFile);
					
					// Értesítés
					Toast.makeText(HTTPClientPeldaActivity.this, "Letöltés kész...", Toast.LENGTH_LONG).show();
					
					// Megnyitás
					showFileInBrowser(malkFile);
						   
				} catch (MalformedURLException e) {
					e.printStackTrace();
				} catch (IOException e) {
					e.printStackTrace();
				}
				
			}
		});
        
        // GET ---------------------------------------------
        getButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
								
				try {					
					// HTTP Cilent: Internet
					HttpClient client = new DefaultHttpClient();
					HttpGet get = new HttpGet(url.getText().toString());
						    get.setHeader("User-Agent", "Android-robot-1.0");
					HttpResponse response = client.execute(get);
					
					Toast.makeText(HTTPClientPeldaActivity.this, "Méret: " + response.getEntity().getContentLength() + " Kb", Toast.LENGTH_LONG).show();
					
					if(response.getStatusLine().getStatusCode() == 200){
						// Forras
						InputStream is = response.getEntity().getContent();
						
						// Mentés folyamata
						saveInputStream(is, malkFile);
						
						// Értesítés
						Toast.makeText(HTTPClientPeldaActivity.this, "Letöltés kész...", Toast.LENGTH_LONG).show();
						
						// Megnyitás
						showFileInBrowser(malkFile);
					}
				} catch (ClientProtocolException e) {
					e.printStackTrace();
				} catch (IOException e) {
					e.printStackTrace();
				}
				
			}
		});
        
        
        // POST ---------------------------------------------
        postButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
								
				try {
					// HTTP Cilent: Internet
					HttpClient client = new DefaultHttpClient();
					HttpPost post = new HttpPost(urlPost.getText().toString());
					List<BasicNameValuePair> pairs = new ArrayList<BasicNameValuePair>();
						pairs.add(new BasicNameValuePair("felhasznalo", username.getText().toString()));
						pairs.add(new BasicNameValuePair("jelszo", password.getText().toString()));
					UrlEncodedFormEntity entity = new UrlEncodedFormEntity(pairs);
					post.setEntity(entity);
					HttpResponse response = client.execute(post);
					int status = response.getStatusLine().getStatusCode(); 
					if(status == 200){					
						// String-é alakítás
						byte[] buffer = new byte[1024];
						int len = response.getEntity().getContent().read(buffer);
						String source = new String(buffer, 0, len);						
						new AlertDialog.Builder(HTTPClientPeldaActivity.this).setMessage(Html.fromHtml(source)).show();
					}else if(status == 403){
						Toast.makeText(HTTPClientPeldaActivity.this, "Hozzáférés megtagadva!", Toast.LENGTH_LONG).show();
					}
					
				} catch (UnsupportedEncodingException e) {
					e.printStackTrace();
				} catch (ClientProtocolException e) {
					e.printStackTrace();
				} catch (IOException e) {				
					e.printStackTrace();
				}
				
				
			}
		});
        
        
    }
    
    // Mentés ide: WRITE_EXTERNAL_STORAGE
    private void saveInputStream(InputStream is, File saveHere){
    	
		try {
			FileOutputStream fos = new FileOutputStream(malkFile);
			byte[] buffer = new byte[1024];
			int len = 0;
			while((len = is.read(buffer)) != -1)					
				fos.write(buffer, 0, len);
			fos.close();
			is.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
    	
    }
    
    
    private void showFileInBrowser(File file){
    	Intent i = new Intent(Intent.ACTION_VIEW);
		   i.setData(Uri.fromFile(malkFile));
		   i.setClassName("com.android.browser", "com.android.browser.BrowserActivity");					
		startActivity(i);
    }
    
    
}